
#include <stdio.h>

#include "com.h"

#define START	127
#define STOP	255


void main(int argc, char* argv[])
{
 HANDLE com;
 int i, n, p;
 unsigned char buffer[64], data[64];
 int temperature;
 int humidity;
 int pressure;
 int wind_speed;
 FILE* file;

 if (argc != 2)
   {
	printf("Errore: deve essere fornito il nome del file come argomento\r\n");
    return;
   }
  
 // apertura file
 file = fopen(argv[1], "wt");
 if (file == NULL)
   {
	printf("Errore apertura file \"%s\"\r\n", argv[1]);
    return;
   }

 // apertura porta seriale
 if ((long)(com = COM_open(1, READ, 9600, 'N', 8, 1, NO_HANDSHAKE)) > 0)
   {
    p = 0;
    while (1)
         {
          n = COM_read(com, buffer, sizeof(buffer)); // ricezione
          if (n > 0)
            {
             for (i=0; i<n; i++) // ricerca caratteri iniziale/finale
			    {
				 if (buffer[i] == START) // carattere iniziale
				   {
					data[0] = buffer[i];
					p = 1;
				   }
				 else
				     {
					  if (buffer[i] == STOP) // carattere finale
					    {
						 if (data[0] == START)
						   {
							// ricostruzione dati
						    temperature = (signed char)data[1];
							humidity = data[2];
							pressure = 1000+(signed char)data[3];
							wind_speed = data[4];
							// visualizzazione dati
							printf("%i,%i,%i,%i\r\n", temperature, humidity, pressure, wind_speed);
							fprintf(file, "%i,%i,%i,%i\r\n", temperature, humidity, pressure, wind_speed);
						   }
						 p = 0;
					    }
					  else // carattere intermedio
					      {
						   data[p] = buffer[i]; // copia carattere
						   p++;
					      }
				     }
				} // fine ciclo for
            } // fine ciclo while
         }
   }
 else
     printf("Errore apertura porta seriale\r\n");
 fclose(file);
}
